// ============================================================================
//
// Unit:    ibeDMDBMain
// Inhalt:  Formular
// Aufgabe: Datenmodul fr Datenbankanwendungen
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit ibeDMDBMain;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
	Dialogs, DB, ADODB,
	ibeDMMain,
	ibeAppServiceProviderDB;

type
	TmodDBMain = class(TmodMain)
		procedure DataModuleCreate(Sender: TObject);
	private
		FAutoConnect: Boolean;
		function GetASP: TibeAppServiceProviderDB;
	protected
		function InternalExecute: Boolean; override;
    procedure DoBeforeOpenConnectionMain(); virtual;
		property AutoConnect: Boolean read FAutoConnect write FAutoConnect;
		property ASP: TibeAppServiceProviderDB read GetASP;
	public
	end;

implementation

{$R *.dfm}

procedure TmodDBMain.DataModuleCreate(Sender: TObject);
begin
	inherited;
	AutoConnect			:= True;
	ASPClass				:= TibeAppServiceProviderDB;
end;

function TmodDBMain.InternalExecute: Boolean;
var bOK: Boolean;
begin
	bOK := inherited InternalExecute;

	if bOK then begin
    asp.Owner := Self;

		ASP.InitMainConnection;

    DoBeforeOpenConnectionMain();
    
    ASP.Connection.Open;
	end;

	Result := bOK;
end;

procedure TmodDBMain.DoBeforeOpenConnectionMain(); 
begin
end;

function TmodDBMain.GetASP: TibeAppServiceProviderDB;
begin
  Result := TibeAppServiceProviderDB(inherited ASP);
end;

end.

