// ============================================================================
//
// Unit:    ibeDMMain
// Inhalt:  Formular
// Aufgabe: Datenmodul
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit ibeDMMain;

interface

uses
	SysUtils, Classes, IniFiles, Forms,
	ibeAppServiceProvider;

type
	TmodMain = class(TDataModule)
    procedure DataModuleDestroy(Sender: TObject);
	private
		FASPClass: TibeAppServiceProviderClass;
		FASP: TibeAppServiceProvider;
	protected
//		function InternalReadConfig(cfg: TIniFile): Boolean; virtual;
		function InternalExecute: Boolean; virtual;
		property ASPClass: TibeAppServiceProviderClass read FASPClass write FASPClass;
	public
		function ActionStartup: Boolean;
		property ASP: TibeAppServiceProvider read FASP;
	end;

implementation

{$R *.dfm}

function TmodMain.ActionStartup: Boolean;
var bOK: Boolean;
begin
	bOK := True;

	if bOK then begin
		FASP := ASPClass.Create;
    StoreASP(ASP);
    ASP.AppExeName := Application.ExeName;
	end;

	if bOK then begin
		bOK := InternalExecute;
	end;

	Result := bOK;
end;

function TmodMain.InternalExecute: Boolean;
begin
	Result := True;
end;

procedure TmodMain.DataModuleDestroy(Sender: TObject);
begin
  StoreASP(nil);
  FASP := nil;
end;

end.

