unit ibeFCommonDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ActnList, StdCtrls, ExtCtrls, Menus, pngimage,
  ibeFCommon,
  ibeAppServiceProvider, System.Actions;

type
  TfrmCommonDialog = class(TfrmCommon)
    actOK: TAction;
    actCancel: TAction;
    pnlTop: TPanel;
    imgMain: TImage;
    lblDialogDescription: TLabel;
    lblDialogTitle: TLabel;
    pnlMain: TPanel;
    pnlBottom: TPanel;
    pnlBottomButton: TPanel;
    btnOK: TButton;
    btnCancel: TButton;
    procedure actOKExecute(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
  private
		function GetASP: TibeAppServiceProvider;
  protected
    function Init(): Boolean; virtual;
    function Validate(): Boolean; virtual;
    procedure InternalActionOK(); virtual; abstract;
    function ActionOK(): Boolean; virtual;
    function ActionCancel(): Boolean; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    function Execute(): Boolean;
		property ASP: TibeAppServiceProvider read GetASP;
  end;

implementation

{$R *.dfm}

constructor TfrmCommonDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  // fr Return hat Delphi keine Shortcuts vordefieniert, daher so erzeugen
  actOK.ShortCut := ShortCut(VK_RETURN, []);
end;

function TfrmCommonDialog.Execute(): Boolean;
var
  LModalResult: TModalResult;
begin
  LModalResult := mrNone;

  if Init() then
  begin
    LModalResult := ShowModal();
  end;

  Result := LModalResult = mrOk;
end;

procedure TfrmCommonDialog.actCancelExecute(Sender: TObject);
begin
  inherited;

  if ActionCancel() then
  begin
    ModalResult := mrCancel;
  end;
end;

procedure TfrmCommonDialog.actOKExecute(Sender: TObject);
begin
  inherited;
  
  if Validate() then
  begin
    Screen.Cursor := crHourGlass;
    try
      InternalActionOK();
    finally
      Screen.Cursor := crDefault;
    end;
  end;
end;

function TfrmCommonDialog.Init(): Boolean;
begin
  Result := True;
end;

function TfrmCommonDialog.Validate(): Boolean;
begin
  Result := True;
end;

function TfrmCommonDialog.ActionOK(): Boolean;
begin
  Result := True;
end;

function TfrmCommonDialog.ActionCancel(): Boolean;
begin
  Result := True;
end;

function TfrmCommonDialog.GetASP: TibeAppServiceProvider;
begin
	Result := RetrieveASP;
end;

end.

