unit ibeFCommonEditHost;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, ExtCtrls, 
  ibeFCommon,
  ibeFCommonEdit, System.Actions;

type
  TibeFrmCommonEditHost = class(TfrmCommon)
    actOK: TAction;
    actCancel: TAction;
    procedure actOKExecute(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
  private
    FFrmEdit: TibeFrmCommonEdit;
    FPKValue: Variant;
    //function GetFrmEditClass(): TibeFrmCommonEditClass;
    //procedure SetFrmEditClass(AFormEditClass: TibeFrmCommonEditClass);
  protected
    property FrmEdit: TibeFrmCommonEdit read FFrmEdit;
    procedure DoShow(); override;
    function RetrieveEditFormContainer(): TWinControl; virtual; abstract;
    function RetrieveFormClientWidth(): Integer; virtual; abstract;
    function RetrieveFormClientHeight(): Integer; virtual; abstract;
  public
    procedure ActionBrowse();
    procedure ActionEdit();
    procedure ActionNew();
    property PKValue: Variant read FPKValue write FPKValue;
    //property FrmEditClass: TibeFrmCommonEditClass read GetFrmEditClass write SetFrmEditClass;
    procedure CreateEditForm(AFormEditClass: TibeFrmCommonEditClass; out AEditForm: TibeFrmCommonEdit);
  end;

TibeFrmCommonEditHostClass = class of TibeFrmCommonEditHost;

implementation

uses
  ibeException;

{$R *.dfm}

procedure TibeFrmCommonEditHost.ActionBrowse();
begin
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionEdit(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.PKValue := PKValue;
  FrmEdit.ActionBrowse();

  ShowModal;
end;

procedure TibeFrmCommonEditHost.ActionEdit();
begin
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionEdit(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.PKValue := PKValue;
  FrmEdit.ActionEdit();

  ShowModal;
end;

procedure TibeFrmCommonEditHost.ActionNew();
begin
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionEdit(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.ActionNew();

  ShowModal;

  PKValue := FrmEdit.PKValue;
end;

procedure TibeFrmCommonEditHost.CreateEditForm(AFormEditClass: TibeFrmCommonEditClass; out AEditForm: TibeFrmCommonEdit);
begin
  if Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.SetFrmEditClass(): es gibt bereits ein Bearbeitungsfenster, die Klasse kann nicht zugewiesen werden');
  end;

  if not Assigned(AFormEditClass) then
  begin
    raise EibeException.Create(Self, 'EditHost.SetFrmEditClass(): die Klasse fr das Bearbeitungsformular muss eine Ableitung von TibeFrmCommonEdit sein');
  end;

  FFrmEdit := AFormEditClass.Create(Self);

  ClientWidth := RetrieveFormClientWidth();
  ClientHeight := RetrieveFormClientHeight();

  FrmEdit.DisplayInContainer(RetrieveEditFormContainer());

  Caption := FrmEdit.Caption;

  AEditForm := FrmEdit;
end;

procedure TibeFrmCommonEditHost.DoShow();
begin
  inherited DoShow();

  FrmEdit.Show();
end;

procedure TibeFrmCommonEditHost.actCancelExecute(Sender: TObject);
begin
  inherited;
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionCancel(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.ActionCancel();

  ModalResult := mrCancel;
end;

procedure TibeFrmCommonEditHost.actOKExecute(Sender: TObject);
var
  LActiveControl: TWinControl;
begin
  inherited;
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionSave(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  // dem aktiven Control des Formulars kurzfristig den Fokus entziehen. Damit
  // werden nderungen an den Daten des Controls automatisch in die Datenpersitenz
  // bernommen
  LActiveControl := ActiveControl;
  ActiveControl := nil;
  ActiveControl := LActiveControl;

  FrmEdit.ActionSave();
  PKValue := FrmEdit.PKValue;

  ModalResult := mrOk;
end;

end.

