// ============================================================================
//
// Unit:    ibeException
// Inhalt:  Formular
// Aufgabe: Klassenbibliothek fr Exceptions
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit ibeException;

interface

uses
	SysUtils;

type

EibeException = class(Exception)
private
	FRaisingObject: TObject;
  FInnerException: Exception;
protected
public
	constructor Create(aRaisingObject: TObject; const aMessage: string); overload; virtual;
	constructor Create(aRaisingObject: TObject; const aMessage: string; aInner: Exception); overload; virtual;
  property InnerException: Exception read FInnerException;
end;

implementation

constructor EibeException.Create(aRaisingObject: TObject; const aMessage: string);
begin
	inherited Create(aMessage);

	FRaisingObject := aRaisingObject;
end;

constructor EibeException.Create(aRaisingObject: TObject; const aMessage: string; aInner: Exception);
begin
  Create(aRaisingObject, aMessage);

  FInnerException := aInner;
end;

end.

