unit ibeMemTable_JvMemoryData;

interface

uses
  DB, DBClient,
  JvMemoryDataset;

type

TibeMemTable = class(TJvMemoryData)
private
protected
public
  function LoadFromDataset(aSource: TDataSet): Integer;
  procedure EmptyTable();
end;

implementation

function TibeMemTable.LoadFromDataset(aSource: TDataSet): Integer;
var
  LSrcField, LDestField: TField;
begin
  Result := inherited LoadFromDataSet(aSource, 0, lmCopy);

  for LSrcField in aSource.Fields do
  begin
    LDestField := Fields[LSrcField.Index];
    LDestField.DisplayLabel := LSrcField.DisplayLabel;

    if LSrcField is TNumericField then
    begin
      TNumericField(LDestField).DisplayFormat := TNumericField(LSrcField).DisplayFormat;
    end;
  end;
end;

procedure TibeMemTable.EmptyTable;
begin
  if Active then begin
    First;

    while not Eof do begin
      Delete;
    end;
  end;
end;

end.
