// ============================================================================
//
// Unit:    ibeOSProcedures
// Inhalt:  Formular
// Aufgabe: Funktionsbibliothek zur Kapselung Betriebssystemabhngiger Methoden
//
//   (c) 2015 by Klaus Etscheid
// ============================================================================
unit ibeOSProcedures;

interface

Uses
{$IFDEF MSWINDOWS}
	Windows, ShellAPI, Winapi.SHFolder, Winapi.ShlObj, Winapi.KnownFolders,
{$ENDIF >>>>MSWINDOWS}
{$IFDEF LINUX}
{$ENDIF >>>>LINUX	}
	System.UITypes, SysUtils, Math;

type

TExecuteCommandOption = (ecoHide, ecoShowNormal);

EEcecuteCommand = class(Exception);

function ExecuteAndWait(const aCommando: string): Integer;
procedure ExecuteCommand(const ACmd, AParams, APath: string; AOpt: TExecuteCommandOption);

type
EGetWindowsPath = class(Exception);

function GetFolderPath(AClassID: TGUID): TFileName;

Function GetTempPath(): String;
Function GetTempFileName(const APathName: TFileName; ACreateFile: Boolean): TFileName;
function GetUserAppDataRoaming(): TFileName;

type
  TibeKeyCode = (
    // Steuerungstasten
    kcCancel = vkCancel,
    kcInsert = vkInsert,
    kcDelete = vkDelete,
    kcBack = vkBack,
    kcClear = vkClear,
    kcPause = vkPause,
    kcSelect = vkSelect,
    kcPrint= vkPrint,
    kcExecute = vkExecute,
    kcSnapshot = vkSnapshot,
    kcHelp = vkHelp,
    kcPrior = vkPrior,
    kcNext = vkNext,
    kcEnd = vkEnd,
    kcHome = vkHome,
    kcWinLeft = vkLWin,
    kcWinRight = vkRWin,
    kcApps = vkApps,
    kcSleep = vkSleep,
    kcCamera = vkCamera,
    kcHardwareBack = vkHardwareBack,
    // Buchstabentasten
    kcTab = vkTab,
    kcReturn = vkReturn,
    kcLineFeed = vkLineFeed,
    kcEscape = vkEscape,
    kcSpace = vkSpace,
    kcA = vkA,
    kcB = vkB,
    kcC = vkC,
    kcD = vkD,
    kcE = vkE,
    kcF = vkF,
    kcG = vkG,
    kcH = vkH,
    kcI = vkI,
    kcJ = vkJ,
    kcK = vkK,
    kcL = vkL,
    kcM = vkM,
    kcN = vkN,
    kcO = vkO,
    kcP = vkP,
    kcQ = vkQ,
    kcR = vkR,
    kcS = vkS,
    kcT = vkT,
    kcU = vkU,
    kcV = vkV,
    kcW = vkW,
    kcX = vkX,
    kcY = vkY,
    kcZ = vkZ,
    // Zahlentasten
    kc0 = vk0,
    kc1 = vk1,
    kc2 = vk2,
    kc3 = vk3,
    kc4 = vk4,
    kc5 = vk5,
    kc6 = vk6,
    kc7 = vk7,
    kc8 = vk8,
    kc9 = vk9,
    // Satzzeichen-Tasten
    kcSemicolon = vkSemicolon,
    kcEqual = vkEqual,
    kcComma = vkComma,
    kcMinus = vkMinus,
    kcPeriod = vkPeriod,
    kcSlash = vkSlash,
    kcTilde = vkTilde,
    kcBracketLeft = vkLeftBracket,
    kcBracketRight = vkRightBracket,
    kcBackslash = vkBackslash,
    kcQuote = vkQuote,
    kcPara = vkPara,
    // Funktionstasten
    kcF1 = vkF1,
    kcF2 = vkF2,
    kcF3 = vkF3,
    kcF4 = vkF4,
    kcF5 = vkF5,
    kcF6 = vkF6,
    kcF7 = vkF7,
    kcF8 = vkF8,
    kcF9 = vkF9,
    kcF10 = vkF10,
    kcF11 = vkF11,
    kcF12 = vkF12,
    kcF13 = vkF13,
    kcF14 = vkF14,
    kcF15 = vkF15,
    kcF16 = vkF16,
    kcF17 = vkF17,
    kcF18 = vkF18,
    kcF19 = vkF19,
    // Nummernblock-Tasten
    kcNumLock = vkNumLock,
    kcNum0 = vkNumpad0,
    kcNum1 = vkNumpad1,
    kcNum2 = vkNumpad2,
    kcNum3 = vkNumpad3,
    kcNum4 = vkNumpad4,
    kcNum5 = vkNumpad5,
    kcNum6 = vkNumpad6,
    kcNum7 = vkNumpad7,
    kcNum8 = vkNumpad8,
    kcNum9 = vkNumpad9,
    // Nummernblock Funktionstasten
    kcMult = vkMultiply,
    kcAdd = vkAdd,
    kcuSubst = vkSubtract,
    kcDiv = vkDivide,
    kcDecimal = vkDecimal,        // Komma/Dezimalpunkt auf Nummernblock?????
    kcSeparator = vkSeparator,    // Enter-Taste auf Nummernblock????
    // modifizierende Tasten
    kcCapital = vkCapital,        // Shift-Lock???
    kcShift = vkSHIFT,
    kcShiftLeft = vkLSHIFT,
    kcShiftRight = vkRSHIFT,
    kcContrl = vkCONTROL,
    kcContrlLeft = vkLCONTROL,
    kcContrlRight = vkRCONTROL,
    kcAlt = vkMENU,
    kcAltLeft = vkLMENU,
    kcAltRight = vkRMENU,
    // Maustasten
    kcMouseLeft = vkLBUTTON,
    kcMouseRight = vkRButton,
    kcMouseMiddle = vkMButton,
    kcMouseScroll = vkScroll,
    // Browser-/Multimedia-Tasten
    kcBrowserBack = vkBrowserBack,
    kcBrowserForward = vkBrowserForward,
    kcBrowserRefresh = vkBrowserRefresh,
    kcBrowserStop = vkBrowserStop,
    kcBrowserSearch = vkBrowserSearch,
    kcBrowserFavorites = vkBrowserFavorites,
    kcBrowserHome = vkBrowserHome,
    kcVolMute = vkVolumeMute,
    kcVolDown = vkVolumeDown,
    kcVolUp = vkVolumeUp,
    kcMediaNextTrack = vkMediaNextTrack,
    kcMediaPrevTrack = vkMediaPrevTrack,
    kcMediaStop = vkMediaStop,
    kcMediaPlyPause = vkMediaPlayPause,
    kcLaunchMail = vkLaunchMail,
    kcLaunchMediaSelect = vkLaunchMediaSelect,
    kcLaunchApp1 = vkLaunchApp1,
    kcLaunchApp2 = vkLaunchApp2,
    // Keine Ahnung wofr die gut sind
    kcIcoHelp = vkIcoHelp,
    kcIco00 = vkIco00,
    kcIcoClear = vkIcoClear,
    kcProcessKey = vkProcessKey,
    kcPacket = vkPacket,
    kcAttn = vkAttn,
    kcCrsel = vkCrsel,
    kcExsel = vkExsel,
    kcErEof = vkErEof,
    kcPlay = vkPlay,
    kcZoom = vkZoom,
    kcNoname = vkNoname,
    kcPA1 = vkPA1,
    kcOEM102 = vkOem102,
    kcOEMClear = vkOemClear
  );

  TibeKeyCodeSet = set of TibeKeyCode;

/// <summary>
///  QueryKeyPressedStatus() liefert True, wenn AKey zum Zeitpunkt des Funktionsaufrufs
///  gedrckt ist
/// <summary>
function QueryKeyPressedStatus(AKey: TibeKeyCode): Boolean;
/// <summary>
///  QueryKeysPressedStatus() liefert True, wenn die Tastenkombination AKeys zum
///  Zeitpunkt des Funktionsaufrufs gedrckt ist
/// <summary>
function QueryKeysPressedStatus(AKeys: TibeKeyCodeSet): Boolean;

function QueryElapsedSeconds(AStartSeconds: Extended = NaN): Extended;

implementation

{$IFDEF MSWINDOWS}

function ExecuteAndWait(const aCommando: string): Integer;
var
  tmpStartupInfo: TStartupInfo;
  tmpProcessInformation: TProcessInformation;
  tmpProgram: String;
  dwExitCode: DWORD;
begin
  Result := 0;

  tmpProgram := trim(aCommando);
  FillChar(tmpStartupInfo, SizeOf(tmpStartupInfo), 0);
  with tmpStartupInfo do
  begin
    cb := SizeOf(TStartupInfo);
    wShowWindow := SW_HIDE;
  end;

  if CreateProcess(nil, pchar(tmpProgram), nil, nil, true, CREATE_NO_WINDOW,
    nil, nil, tmpStartupInfo, tmpProcessInformation) then
  begin
    // loop every 10 ms
    while WaitForSingleObject(tmpProcessInformation.hProcess, 10) > 0 do
    begin
      if GetExitCodeProcess(tmpProcessInformation.hProcess, dwExitCode) then
      begin
        Result := dwExitCode;

        if dwExitCode <> 0 then
        begin
          SetLastError(dwExitCode + $2000);
        end;
      end;
    end;

//    repeat
//      Inc(Result);
//      LWaitResult := WaitForSingleObject(tmpProcessInformation.hProcess, 10);
//    until LWaitResult > WAIT_OBJECT_0;
//
//    if GetExitCodeProcess(tmpProcessInformation.hProcess, dwExitCode) then
//    begin
//      if dwExitCode <> 0 then
//        SetLastError(dwExitCode + $2000);
//    end;

    CloseHandle(tmpProcessInformation.hProcess);
    CloseHandle(tmpProcessInformation.hThread);
  end else
  begin
    RaiseLastOSError;
  end;
end;

procedure ExecuteCommand(const ACmd, AParams, APath: string; AOpt: TExecuteCommandOption);
var
  LOpt: Integer;
  LPPath: Pointer;
  LResult: HINST;
begin
  case AOpt of
    ecoHide:        LOpt := SW_HIDE;
    ecoShowNormal:  LOpt := SW_SHOWNORMAL;
  else
    raise EEcecuteCommand.Create('ExecuteCommend("' + ACmd + '", ...) Nicht untersttzte Option #' + IntToStr(Ord(AOpt)));
  end;

  if APath <> '' then
  begin
    LPPath := @(APath[1]);
  end else
  begin
    LPPath := nil;
  end;
  
  LResult := ShellExecute(0, 'open', @(ACmd[1]), @(AParams[1]), LPPath, LOpt);

  if LResult <= 32 then
  begin
    raise EEcecuteCommand.Create('ExecuteCommend("' + ACmd + '", ...) wurde mit Fehlercode #' + IntToStr(LResult) + ' abgebrochen');
  end;
end;

Type

TWindowsPathFunction = function(nBufferLength: DWORD; lpBuffer: PChar): DWORD; stdcall;

Function GetWindowsPath(a_PathFunction: TWindowsPathFunction): string;
var pc: PChar;
	ps: DWord;
begin
	pc			:= nil;
	Result	:= '';
	try
		ps			:= MAX_PATH;
		pc			:= StrAlloc( ps );
		a_PathFunction( ps, pc );
		Result	:= StrPas( pc );
	finally
		if pc <> nil then StrDispose(pc);
	end;
End;

function GetTempPath(): string;
begin
	Result := GetWindowsPath(Windows.GetTempPath);
end;

Function GetTempFileName(const APathName: TFileName; ACreateFile: Boolean): TFileName;
var
  LTempFileName: Array[0..MAX_PATH] of char;
begin
  windows.GetTempFileName(@APathName[1], nil, Ord(ACreateFile), LTempFileName);

  Result := LTempFileName;
end;

function GetFolderPath(AClassID: TGUID): TFileName;
var
  LResCode: Integer;
  LPPath: LPWSTR;
begin
  LPPath := nil;
  LResCode := SHGetKnownFolderPath(AClassID, 0, 0, LPPath);

  if LResCode = S_OK then
  begin
    Result := LPPath;
  end else
  begin
    raise EGetWindowsPath.CreateFmt('GetFolderPath(%s): der Pfad konnte nicht ermittelt werden, Fehlercode ist %d', [AClassID.ToString, LResCode]);
  end;
end;

function GetUserAppDataRoaming(): TFileName;
begin
  Result := GetFolderPath(FOLDERID_RoamingAppData);
end;

function QueryKeyPressedStatus(AKey: TibeKeyCode): Boolean;
var
  LKeyState: Integer;
begin
  LKeyState := GetAsyncKeyState(Ord(AKey));

  Result := LKeyState < 0;
end;

function QueryKeysPressedStatus(AKeys: TibeKeyCodeSet): Boolean;
var
  LKeyCode: TibeKeyCode;
  LKeyState: Integer;
begin
  Result := AKeys <> [];  // es muss mindestens eine Taste im Set sein

  if Result then
  begin
    for LKeyCode in AKeys do
    begin
      LKeyState := GetAsyncKeyState(Ord(LKeyCode));

      Result := LKeyState < 0;
      if not Result then
      begin
        Break;
      end;
    end;
  end;
end;

function ElapsedSecondsByPerformanceCounter(StartSeconds: Extended = NaN): Extended;
var Timer, Frequenzy: Int64;
begin
	QueryPerformanceFrequency(Frequenzy);
	QueryPerformanceCounter(Timer);

	Result := Timer / Frequenzy;

	if not IsNaN(StartSeconds) then begin
		Result := Result - StartSeconds;
	end;
end;

function ElapsedSecondsByTimerTics(StartSeconds: Extended = NaN): Extended;
begin
	Result := GetTickCount / 1000.0;

	if not IsNaN(StartSeconds) then begin
		Result := Result - StartSeconds;
	end;
end;

function QueryElapsedSeconds(AStartSeconds: Extended = NaN): Extended;
begin
  Result := ElapsedSecondsByPerformanceCounter(AStartSeconds);
end;

{$ENDIF >>>>MSWINDOWS}

end.
