unit ibeSQLCreateDatabase;

interface

uses
  SysUtils, Variants, Classes,
  ibeString, ibeTypes, ibeException,
  ibeDALConnection;

type

TibeSQLCreateDatabase = class
private
protected
public
end;

TibeSQLCreateDatabase_MSSQL = class(TibeSQLCreateDatabase)
private
protected
public
end;

TibeSQLCreateDatabase_FB = class(TibeSQLCreateDatabase)
private
protected
public
end;

TibeSQLCreateDatabaseClass = class of TibeSQLCreateDatabase;

TibeSQLCreateDatabaseFactory = class
private
protected
public
  class function RetriveClass(const ADBMS_ID: string): TibeSQLCreateDatabaseClass;
  class function CreateInstance(const ADBMS_ID: string): TibeSQLCreateDatabase;
  class procedure RegisterClass(const ADBMS_ID: string; ADatabaseCreateClass: TibeSQLCreateDatabaseClass);
end;

EibeSQLCreateDatabase = class(EibeException);
EibeSQLCreateDatabaseFactory = class(EibeSQLCreateDatabase);

implementation

uses
  ibeSQLScript;

// =================== [ TibeSQLCreateDatabaseFactory ] ========================
  
var
  m_slRegisteredCreateDatabases: TStringList;

class function TibeSQLCreateDatabaseFactory.RetriveClass(const ADBMS_ID: string): TibeSQLCreateDatabaseClass;
var
  idx: Integer;
  LCdreateDatabaseClass: TibeSQLCreateDatabaseClass;
begin
  if Assigned(m_slRegisteredCreateDatabases) then
  begin
    idx := m_slRegisteredCreateDatabases.IndexOf(ADBMS_ID);

    if idx >= 0 then
    begin
      LCdreateDatabaseClass := TibeSQLCreateDatabaseClass(m_slRegisteredCreateDatabases.Objects[idx]);
    end else
    begin
      raise EibeSQLCreateDatabaseFactory.Create('TibeSQLCreateDatabaseFactory.RetriveClass(): fr das Datenbank-Management-System "'
                           + ADBMS_ID + '" ist ist keine Klasse registriert');
    end;
  end else
  begin
    raise EibeSQLCreateDatabaseFactory.Create('TibeSQLCreateDatabaseFactory.RetriveClass(): es ist noch keine SQLCreateDatabase-Klasse registriert');
  end;

  Result := LCdreateDatabaseClass;
end;

class function TibeSQLCreateDatabaseFactory.CreateInstance(const ADBMS_ID: string): TibeSQLCreateDatabase;
begin
  Result := RetriveClass(ADBMS_ID).Create();
end;

class procedure TibeSQLCreateDatabaseFactory.RegisterClass(const ADBMS_ID: string; ADatabaseCreateClass: TibeSQLCreateDatabaseClass);
begin
  if not Assigned(m_slRegisteredCreateDatabases) then
  begin
    m_slRegisteredCreateDatabases := TStringList.Create;
  end;

  m_slRegisteredCreateDatabases.AddObject(ADBMS_ID, TObject(ADatabaseCreateClass));
end;

initialization

TibeSQLCreateDatabaseFactory.RegisterClass(gc_sDBMS_ID_MSSQL, TibeSQLCreateDatabase_MSSQL);
TibeSQLCreateDatabaseFactory.RegisterClass(gc_sDBMS_ID_Firebird, TibeSQLCreateDatabase_FB);

finalization

FreeAndNil(m_slRegisteredCreateDatabases);

end.
