unit libControlUtil;

interface

uses
  sysUtils, Classes, Controls, Data.DB,
  ibeMemTable, ibeDALConnection, ibeDataObject;

type

//TDOInitiatorProc = reference to procedure(ADO: TibeDataObject);
TDOInitiatorProc<T> = reference to procedure(const ADO: TibeDataObject);

function RetrieveLookupDataSource(AOwner: TComponent; AConnection: TibeDALConnection; ADOClass: TibeDataObjectClass; const ADOConfigProc: TDOInitiatorProc<TibeDataObject> = nil): TDataSource;

implementation

function RetrieveLookupDataSource(AOwner: TComponent; AConnection: TibeDALConnection; ADOClass: TibeDataObjectClass; const ADOConfigProc: TDOInitiatorProc<TibeDataObject>): TDataSource;
var
  LDat: TibeMemTable;
  LSrc: TDataSource;
  LDO: TibeDataObject;
begin
  LDat := TibeMemTable.Create(AOwner);
  try
    LSrc :=  TDataSource.Create(AOwner);
    try
      LDO := ADOClass.Create(AConnection);
      try
        if Assigned(ADOConfigProc) then
        begin
          ADOConfigProc(LDO);
        end;
        LDO.Refresh();
        LDO.DataCopyToDataset(LDat);

        LSrc.DataSet := LDat;
      finally
        FreeAndNil(LDO);
      end;
    except
      FreeAndNil(LSrc);
      raise;
    end;
  except
    FreeAndNil(LDat);
    raise;
  end;

  Result := LSrc;
end;

end.

