unit libProgramFunctions;

interface

uses
  ibeProgramFunctionManager;

const
  // Objekte
  PF_OBJ_ARTICLE = 'OBJ_ARTICLE';
  PF_OBJ_MEASUREMENTDEVICE = 'OBJ_MEASUREMENTDEVICE';
  // Projekte
  PF_PRJ_TASK = 'PRJ_TASK';
  PF_PRJ_TASK_TIME_ENTRY = 'PRJ_TASK_TIME_ENTRY';
  PF_PRJ_SERVICE_REPORT_ENTRY = 'PRJ_SERVICE_REPORT_ENTRY';
  // Organisation
  PF_ORG_CALENDAR = 'ORG_CALENDAR';
  PF_ORG_TIME = 'ORG_TIME';
  PF_ORG_EMPLOYEE = 'ORG_EMPLOYEE';
  PF_ORG_EMP_CALENDAR = 'ORG_EMP_CALENDAR';
  // Umweltdaten
  PF_ENV_WEATHER = 'ENV_WEATHER';
  PF_ENV_WEATHER_LIST = 'ENV_WEATHER_LIST';
  PF_VAL_WEATHER_LIST = 'VAL_WEATHER_LIST';

procedure RegisterProgramFunctions();

implementation

uses
  // Objekte
  FobjArticleList,
  FObjMeasurementDeviceList,
  // Projekte
  FprjTaskList,
  FprjTaskTimeEntryList,
  FprjServiceReportEntryList,
  // Organisation
  FcalStammDayList, FcalStammTimeList,
  ForgStammEmployeeList,
  empFEmployeeCalendarList,
  // Umweltdaten
  FenvWeatherContainer,
  FvalWeatherDataList,
  FenvWeatherDataList;

procedure RegisterProgramFunctions();
begin
  // Objekte
  TfrmObjArticleList.DoRegisterProgramFunction();
  TfrmObjMeasurementDeviceList.DoRegisterProgramFunction();
  // Projekte
  TfrmPrjSREList.DoRegisterProgramFunction();
  TfrmPrjTaskList.DoRegisterProgramFunction();
  TfrmPrjTTEList.DoRegisterProgramFunction();
  // Organisation
  TfrmCalDayList.DoRegisterProgramFunction();
  TfrmCalTimeList.DoRegisterProgramFunction();
  TfrmOrgEmployeeList.DoRegisterProgramFunction();
  TfrmEmployeeCalendarList.DoRegisterProgramFunction();
  //Diverses fr Klaus
  TfrmEnvWeatherContainer.DoRegisterProgramFunction();
  TfrmEnvWeatherDataList.DoRegisterProgramFunction();
  TfrmValWeatherDataList.DoRegisterProgramFunction();
end;

end.

