unit FDODDataEdit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.Actions,
  Vcl.ActnList, Vcl.ExtCtrls,
  ibeDataObjectTypes,
  FDODLibCommonEdit,
  DODLibEditClasses;

type
  TfrmDODDataEdit = class(TfrmDODLibCommonEdit)
    Label1: TLabel;
    cboMainTable: TComboBox;
    Label2: TLabel;
    cboPKField: TComboBox;
    Label3: TLabel;
    cboPKValueMode: TComboBox;
    cboMainView: TComboBox;
    Label4: TLabel;
  private
  protected
    procedure DataLoad(); override;
    procedure DataDisplay(); override;
    procedure DataStore(); override;
    procedure DataSave(); override;
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.dfm}

constructor TfrmDODDataEdit.Create(AOwner: TComponent);
var
  LPKMode: TibeDOPKValueMode;
begin
  inherited Create(AOwner);

  cboPKValueMode.Clear();
  for LPKMode := Low(TibeDOPKValueMode) to High(TibeDOPKValueMode) do
  begin
    cboPKValueMode.Items.Add(PKValueModeNameArray[LPKMode]);
  end;
end;

procedure TfrmDODDataEdit.DataLoad();
var
  LTable: TDODLibEditTable;
  LField: TDODLibEditTableField;
  LView: TDODLibEditView;
begin
  cboMainTable.Clear();
  for LTable in DODMain.Tables do
  begin
    cboMainTable.Items.Add(LTable.Data.Alias);
  end;

  cboPKField.Clear();
  for LField in DODMain.TableFields do
  begin
    cboPKField.Items.Add(LField.Data.Alias);
  end;

  cboPKField.Clear();
  for LField in DODMain.TableFields do
  begin
    cboPKField.Items.Add(LField.Data.Alias);
  end;

  cboMainView.Clear();
  for LView in DODMain.Views do
  begin
    cboMainView.Items.AddObject(LView.Name, LView);
  end;
end;

procedure TfrmDODDataEdit.DataDisplay();
begin
  cboMainTable.ItemIndex := cboMainTable.Items.IndexOf(DODMain.MainTableAlias);
  cboPKField.ItemIndex := cboPKField.Items.IndexOf(DODMain.MainTablePKName);
  cboPKValueMode.ItemIndex := cboPKValueMode.Items.IndexOf(PKValueModeNameArray[DODMain.MainTableKKValueMode]);
  cboMainView.ItemIndex := cboMainView.Items.IndexOf(DODMain.MainViewName);
end;

procedure TfrmDODDataEdit.DataStore();
begin
end;

procedure TfrmDODDataEdit.DataSave();
var
  LPKMode: TibeDOPKValueMode;
begin
  for LPKMode := Low(TibeDOPKValueMode) to High(TibeDOPKValueMode) do
  begin
    if SameText(PKValueModeNameArray[LPKMode], cboPKValueMode.Text) then
    begin
      DODMain.MainTableKKValueMode := LPKMode;
      Break;
    end;
  end;

  DODMain.MainTableAlias := cboMainTable.Text;
  DODMain.MainTablePKName := cboPKField.Text;
  DODMain.MainViewID := TDODLibEditView(cboMainView.Items.Objects[cboMainView.ItemIndex]).ID;

  DODMain.NotifyObservers(dosDOD, doeObjectUpdate, -1);
end;

end.

