unit FDODLibCommonList;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, System.ImageList, Vcl.ImgList, Vcl.ToolWin, Vcl.ComCtrls,
  System.Actions, Vcl.ActnList, Vcl.StdCtrls, Vcl.ExtCtrls,
  ibeFCommonList, ibeFCommonEdit, ibeFCommonEditHost,
  ibeAppServiceProviderDB,
  DODLibEditClasses,
  FDODLibCommonEdit;

type
  TfrmDODLibCommonList = class(TibeFrmCommonList)
    tbMain: TToolBar;
    ilEnabled: TImageList;
    ilHot: TImageList;
    ilDisabled: TImageList;
  private
    FDODMain: TDODLibDataObjectDefinition;
    function GetASP(): TibeAppServiceProviderDB;
  protected
    procedure DoBeforeEdit(AEditForm: TibeFrmCommonEdit; AEditMode: TibeEditMode); override;
    function RetrieveEditHostClass(): TibeFrmCommonEditHostClass; override;
    procedure SetDODMain(ADOD: TDODLibDataObjectDefinition); virtual;
  public
    property DODMain: TDODLibDataObjectDefinition read FDODMain write SetDODMain;
    property ASP: TibeAppServiceProviderDB read GetASP;
  end;

implementation

uses
  libFCommonEditHost;

{$R *.dfm}

procedure TfrmDODLibCommonList.DoBeforeEdit(AEditForm: TibeFrmCommonEdit; AEditMode: TibeEditMode);
begin
  inherited DoBeforeEdit(AEditForm, AEditMode);

  TfrmDODLibCommonEdit(AEditForm).DODMain := DODMain;
end;

function TfrmDODLibCommonList.RetrieveEditHostClass(): TibeFrmCommonEditHostClass;
begin
  Result := TlibFrmCommonEditHost;
end;

procedure TfrmDODLibCommonList.SetDODMain(ADOD: TDODLibDataObjectDefinition);
begin
  FDODMain := ADOD;
end;

function TfrmDODLibCommonList.GetASP(): TibeAppServiceProviderDB;
begin
  Result := TibeAppServiceProviderDB(inherited ASP);
end;

end.

