unit FDODPersistanceEdit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ibeFCommon, System.Actions, Vcl.ActnList,
  Vcl.ExtCtrls,
  ibeDataObjectDefinition,
  DODLibEditClasses,
  FDODTableList, FDODTableFieldList;

type
  TfrmDODPersistanceEdit = class(TfrmCommon)
    spTableHeight: TSplitter;
    pnlTableList: TPanel;
    pnlFieldList: TPanel;
    procedure FormCreate(Sender: TObject);
  private
    FFrmTables: TfrmDODTableList;
    FFrmTableFields: TfrmDODTableFieldList;
    function GetDODMain(): TDODLibDataObjectDefinition;
    procedure SetDODMain(ADataObjectDefinition: TDODLibDataObjectDefinition);
  protected
    property FrmTables: TfrmDODTableList read FFrmTables;
    property FrmTableFields: TfrmDODTableFieldList read FFrmTableFields;
  public
    property DODMain: TDODLibDataObjectDefinition read GetDODMain write SetDODMain;
    procedure ActionRefresh();
  end;

implementation

{$R *.dfm}

procedure TfrmDODPersistanceEdit.FormCreate(Sender: TObject);
begin
  inherited;

  FFrmTables := TfrmDODTableList.Create(Self);
  FrmTables.DisplayInContainer(pnlTableList);
  FrmTables.Show();

  FFrmTableFields := TfrmDODTableFieldList.Create(Self);
  FrmTableFields.DisplayInContainer(pnlFieldList);
  FrmTableFields.Show();
end;

procedure TfrmDODPersistanceEdit.ActionRefresh();
begin
  FrmTables.ActionRefresh();
  FrmTableFields.ActionRefresh();
end;

function TfrmDODPersistanceEdit.GetDODMain(): TDODLibDataObjectDefinition;
begin
  Result := FrmTables.DODMain;
end;

procedure TfrmDODPersistanceEdit.SetDODMain(ADataObjectDefinition: TDODLibDataObjectDefinition);
begin
  FrmTables.DODMain := ADataObjectDefinition;
  FrmTableFields.DODMain := ADataObjectDefinition;
end;

end.

