unit FDODViewTestContainer;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, System.Actions,
  Vcl.ActnList, Vcl.ComCtrls, Vcl.ExtCtrls,
  ibeFCommonContainer,
  FDODViewTestList, FDODViewTestSQL;

type
  TfrmDODViewTestContainer = class(TfrmCommonContainer)
    procedure FormCreate(Sender: TObject);
  private
    FFrmViewList: TfrmDODViewTestList;
    FFrmViewSQL: TfrmDODViewTestSQL;
    procedure OnViewListSQLChanged(const ASQL: string);
  protected
    property FrmViewList: TfrmDODViewTestList read FFrmViewList;
    property FrmViewSQL: TfrmDODViewTestSQL read FFrmViewSQL;
  public
    constructor Create(AOwner: TComponent); override;
    procedure ActionRefresh();
    procedure DODLoadFromStream(ADODStream: TStream; const AActiveViewName: string);
  end;

implementation

{$R *.dfm}

constructor TfrmDODViewTestContainer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TfrmDODViewTestContainer.FormCreate(Sender: TObject);
begin
  inherited;

  FFrmViewList := TfrmDODViewTestList(AddForm(TfrmDODViewTestList, False));
  FFrmViewSQL := TfrmDODViewTestSQL(AddForm(TfrmDODViewTestSQL, False));

  FrmViewList.OnSQLChanged := OnViewListSQLChanged;
end;

procedure TfrmDODViewTestContainer.ActionRefresh();
begin
  ActivateForm(FrmViewList);
end;

procedure TfrmDODViewTestContainer.DODLoadFromStream(ADODStream: TStream; const AActiveViewName: string);
begin
  FrmViewList.DODLoadFromStream(ADODStream, AActiveViewName);
end;

procedure TfrmDODViewTestContainer.OnViewListSQLChanged(const ASQL: string);
begin
  FrmViewSQL.SQL := ASQL;
end;

end.

