unit FdodEditMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.Actions, Vcl.ActnList,
  Vcl.Menus, Vcl.ExtCtrls, System.UITypes,
  ibeAppServiceProviderDB,
  FDODEditor;

type
  TfrmDODEditMain = class(TForm)
    dlgOpenDOD: TFileOpenDialog;
    tiStartupDelay: TTimer;
    alMain: TActionList;
    mnuMain: TMainMenu;
    actDODOpen: TAction;
    Datei1: TMenuItem;
    DODffnen1: TMenuItem;
    actDODSave: TAction;
    actDODSaveAs: TAction;
    dlgSaveDODAs: TSaveDialog;
    Speichern1: TMenuItem;
    Speichernunter1: TMenuItem;
    actDODNew: TAction;
    DODNeu1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure actDODOpenExecute(Sender: TObject);
    procedure tiStartupDelayTimer(Sender: TObject);
    procedure actDODSaveExecute(Sender: TObject);
    procedure actDODSaveAsExecute(Sender: TObject);
    procedure actDODNewExecute(Sender: TObject);
  private
    FFrmEditor: TfrmDODEditor;
  protected
    property FrmEditor: TfrmDODEditor read FFrmEditor;
  public
  end;

var
  frmDODEditMain: TfrmDODEditMain;

implementation

uses
  modMain,
  ibeString;

{$R *.dfm}

procedure TfrmDODEditMain.FormCreate(Sender: TObject);
begin
  dlgOpenDOD.DefaultFolder := RetrieveASP().DOCfgPath;
  dlgSaveDODAs.InitialDir := RetrieveASP().DOCfgPath;

  FFrmEditor := TfrmDODEditor.Create(Self);

  FrmEditor.DisplayInContainer(Self);
  FrmEditor.Show();

  tiStartupDelay.Enabled := True;
end;

procedure TfrmDODEditMain.tiStartupDelayTimer(Sender: TObject);
begin
  tiStartupDelay.Enabled := False;

  actDODOpen.Execute();

  if not FrmEditor.DODIsLoaded then
  begin
    FrmEditor.NewDOD();
  end;
end;

procedure TfrmDODEditMain.actDODNewExecute(Sender: TObject);
begin
  dlgOpenDOD.FileName := '';
  dlgSaveDODAs.FileName := '';
  FrmEditor.NewDOD();
end;

procedure TfrmDODEditMain.actDODOpenExecute(Sender: TObject);
begin
  if dlgOpenDOD.Execute then
  begin
    Caption := 'DOD Editor';

    FrmEditor.LoadFromFile(dlgOpenDOD.FileName);

    Caption := 'DOD Editor [' + ExtractFileName(dlgOpenDOD.FileName) + ']';
  end;
end;

procedure TfrmDODEditMain.actDODSaveAsExecute(Sender: TObject);
var
  LMessage: string;
begin
  if FrmEditor.Validate(LMessage) then
  begin
    if dlgSaveDODAs.FileName = '' then
    begin
      dlgSaveDODAs.FileName := ExtractFileName(dlgOpenDOD.FileName);
    end;

    if dlgSaveDODAs.Execute then
    begin
      FFrmEditor.SaveToFile(dlgSaveDODAs.FileName);
      dlgOpenDOD.FileName := dlgSaveDODAs.FileName;
    end;
  end else
  begin
    MessageDlg(LMessage, mtError, [mbOK], 0);
  end;
end;

procedure TfrmDODEditMain.actDODSaveExecute(Sender: TObject);
var
  LMessage: string;
begin
  if FrmEditor.Validate(LMessage) then
  begin
    if dlgOpenDOD.FileName <> '' then
    begin
      // speichert das DOD unter dem Originalnamen ab
      FrmEditor.SaveToFile(dlgOpenDOD.FileName);
    end else
    begin
      // wenn kein Dateiname bekannt ist wird die "Speichern unter" verwendet
      actDODSaveAs.Execute();
    end;
  end else
  begin
    MessageDlg(LMessage, mtError, [mbOK], 0);
  end;
end;

end.

